diff --git a/ChangeLog b/ChangeLog
index 06250f9..b2cec4f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+2018-01-31  Dmitry V. Levin  <ldv@altlinux.org>
+
+	* manual/install.texi (Tools for Compilation): Update the newest
+	versions of gcc, binutils, texinfo, gawk, bison, and sed.
+	* INSTALL: Regenerated.
+
 2018-01-30  Samuel Thibault  <samuel.thibault@ens-lyon.org
 
 	* sysdeps/pthread/allocalim.h (__libc_use_alloca): Use __glibc_likely
diff --git a/INSTALL b/INSTALL
index 42508e6..68b9252 100644
--- a/INSTALL
+++ b/INSTALL
@@ -419,7 +419,7 @@ build the GNU C Library:
      GCC 4.9 or higher is required.  In general it is recommended to use
      the newest version of the compiler that is known to work for
      building the GNU C Library, as newer compilers usually produce
-     better code.  As of release time, GCC 7.1 is the newest compiler
+     better code.  As of release time, GCC 7.3.1 is the newest compiler
      verified to work to build the GNU C Library.
 
      For PowerPC 64-bits little-endian (powerpc64le), GCC 6.2 or higher
@@ -446,7 +446,7 @@ build the GNU C Library:
 
      You must use GNU 'binutils' (as and ld) to build the GNU C Library.
      No other assembler or linker has the necessary functionality at the
-     moment.  As of release time, GNU 'binutils' 2.27 is the newest
+     moment.  As of release time, GNU 'binutils' 2.29.1 is the newest
      verified to work to build the GNU C Library.
 
    * GNU 'texinfo' 4.7 or later
@@ -455,7 +455,7 @@ build the GNU C Library:
      need this version of the 'texinfo' package.  Earlier versions do
      not understand all the tags used in the document, and the
      installation mechanism for the info files is not present or works
-     differently.  As of release time, 'texinfo' 6.0 is the newest
+     differently.  As of release time, 'texinfo' 6.5 is the newest
      verified to work to build the GNU C Library.
 
    * GNU 'awk' 3.1.2, or higher
@@ -463,13 +463,14 @@ build the GNU C Library:
      'awk' is used in several places to generate files.  Some 'gawk'
      extensions are used, including the 'asorti' function, which was
      introduced in version 3.1.2 of 'gawk'.  As of release time, 'gawk'
-     version 4.1.3 is the newest verified to work to build the GNU C
+     version 4.2.0 is the newest verified to work to build the GNU C
      Library.
 
    * GNU 'bison' 2.7 or later
 
      'bison' is used to generate the 'yacc' parser code in the 'intl'
-     subdirectory.
+     subdirectory.  As of release time, 'bison' version 3.0.4 is the
+     newest verified to work to build the GNU C Library.
 
    * Perl 5
 
@@ -480,7 +481,7 @@ build the GNU C Library:
 
      'Sed' is used in several places to generate files.  Most scripts
      work with any version of 'sed'.  As of release time, 'sed' version
-     4.2.2 is the newest verified to work to build the GNU C Library.
+     4.4 is the newest verified to work to build the GNU C Library.
 
 If you change any of the 'configure.ac' files you will also need
 
diff --git a/manual/install.texi b/manual/install.texi
index 50e6c35..efcd986 100644
--- a/manual/install.texi
+++ b/manual/install.texi
@@ -465,7 +465,7 @@ GCC 4.9 or newer
 GCC 4.9 or higher is required.  In general it is recommended to use
 the newest version of the compiler that is known to work for building
 @theglibc{}, as newer compilers usually produce better code.  As of
-release time, GCC 7.1 is the newest compiler verified to work to build
+release time, GCC 7.3.1 is the newest compiler verified to work to build
 @theglibc{}.
 
 For PowerPC 64-bits little-endian (powerpc64le), GCC 6.2 or higher is
@@ -490,7 +490,7 @@ GNU @code{binutils} 2.25 or later
 
 You must use GNU @code{binutils} (as and ld) to build @theglibc{}.
 No other assembler or linker has the necessary functionality at the
-moment. As of release time, GNU @code{binutils} 2.27 is the newest
+moment. As of release time, GNU @code{binutils} 2.29.1 is the newest
 verified to work to build @theglibc{}.
 
 @item
@@ -500,7 +500,7 @@ To correctly translate and install the Texinfo documentation you need
 this version of the @code{texinfo} package.  Earlier versions do not
 understand all the tags used in the document, and the installation
 mechanism for the info files is not present or works differently.
-As of release time, @code{texinfo} 6.0 is the newest verified to work
+As of release time, @code{texinfo} 6.5 is the newest verified to work
 to build @theglibc{}.
 
 @item
@@ -509,14 +509,15 @@ GNU @code{awk} 3.1.2, or higher
 @code{awk} is used in several places to generate files.
 Some @code{gawk} extensions are used, including the @code{asorti}
 function, which was introduced in version 3.1.2 of @code{gawk}.
-As of release time, @code{gawk} version 4.1.3 is the newest verified
+As of release time, @code{gawk} version 4.2.0 is the newest verified
 to work to build @theglibc{}.
 
 @item
 GNU @code{bison} 2.7 or later
 
 @code{bison} is used to generate the @code{yacc} parser code in the @file{intl}
-subdirectory.
+subdirectory.  As of release time, @code{bison} version 3.0.4 is the newest
+verified to work to build @theglibc{}.
 
 @item
 Perl 5
@@ -529,7 +530,7 @@ GNU @code{sed} 3.02 or newer
 
 @code{Sed} is used in several places to generate files.  Most scripts work
 with any version of @code{sed}.  As of release time, @code{sed} version
-4.2.2 is the newest verified to work to build @theglibc{}.
+4.4 is the newest verified to work to build @theglibc{}.
 
 @end itemize
 